
	/*
	--------------------------------------------------------------

		Brad Perkins  
		
		Intelligence Mfg Company
		3136 Redwood Ave
		West Sacramento, CA 95691
	
	
	Returning Table Names, Fieldnames and Field Types To OV
	
	
	
	--------------------------------------------------------------
	*/




	GLOBAL PREDICATES
	
	
	determ BOOL Get_Table_Field(HWND,OvCallBack_Put,OvCallBack_Put,OVCallBack_Put,String,String,String) 
				- (i,i,i,i,i,i,i) language pascal


	CONSTANTS
	
	
	
	/* FIELD_NAME_LIST DIALOG */
	
	
   	idd_filename		= 16
   	idd_files		= 18
   	idd_path		= 17
   	idd_dirs		= 19
   	idd_fieldname		= 20
   	idd_fields		= 77
   	
   	
   	
	
	/* attribute flags for DlgDirList */
   	attr_dirs		= 0xc010	/* find drives and directories */
   	attr_files		= 0x0000	/* find ordinary files	       */
   	prop_filename		= "FILENAME"	/* name of property for dialog */
   	deffilesearch        	= "*.DB"        /* Paradox Tables Only */

	/* edit control identifier */
	
   	% id_edit              = 0xCAC


	/* strings */

   	ids_cantopen		= 1


	DATABASE - properties
	
	property(string,String)
	

	

	PREDICATES
	
	set_prop(string,String)


	FileOpenDlgProc : DIALOGFUNC 

	CLAUSES
	
	set_prop(Prop,Param) :-
		retractall(property(Prop,_)),
		assert(property(Prop,Param)).
	





	/*
	-------------------------------------------------------------
 									    
 	FUNCTION   : MPError ( hwnd, flags, id, ...)			    
 									    
 	PURPOSE    : Flashes a Message Box to the user. The format string 
 		     is taken from the STRINGTABLE.				    
 									    
   	RETURNS    : Returns value returned by MessageBox() to the caller.	    
   	--------------------------------------------------------------
   	*/
   	
   	
   	PREDICATES
   	
  	mp_error(HWND,WORD,integer,string,integer)

	CLAUSES

  	mp_error(Wnd,Flags,Id,Caption,Answer):-
		inst(Instance),!,
    		str_len(Text,80),
    		LoadString(Instance,Id,Text,80),
    		format(STR,Text,Caption),
    		Answer = MessageBox(Wnd,STR,"IBIS-PLUS",Flags).


	/*
	-------------------------------------------------------------
							
	FUNCTION   : Get_Table_Field
							
	PURPOSE: Gets a table and field and fields type from the user 
	by calling an appropriate dialog box and storing selected
	values in PROP(item,Value).  There are three _PUT_ callback
	function pointers passed as arguments in Get_Table_Field.
	This also uses several of the Paradox Engine functions to
	load the dialog list controls.  This is the main and most
	commented function.  In order to make other fancy DLLs 
	yourself only requires a desire to do so, along with alot
	of study and persistance. Examining others windows code when
	available, is a great educational source.  


	PROTOTYPE:
	
	BOOL Get_Table_Field(HWND,OVTableFieldName,OVFieldNameFieldName,
		OVFieldType)
									   
	--------------------------------------------------------------
	*/
	
	
  
	CLAUSES
	
	Get_Table_Field(Wnd,Ov_Table,Ov_Field,Ov_Type,TableName,FieldName,FieldType,b_true):-
		inst(Instance),
		DialogBox(Instance,"TABLE_FIELD",Wnd,fileOpenDlgProc),% open our dialog box
		property(prop_filename,Filename),% retrieve stored values fro dialog
		property(prop_fieldname,Field),
		Ov_Table(TableName,FileName),   % The (1st) callback loads the OV demo Tablename Field
		Ov_Field(FieldName,Field),      % The (2nd) callback loads the OV demo FieldName Field
    		pXTblOpen(FileName,TableHandle,0,0),  %  Get Table Handle
		PXFldHandle(TableHandle,Field,FieldHandle), % Get Field Handle
		Str_Len(Type,bufsiz),		% Allocate a buffer for the type string
		PXFldType(TableHandle,FieldHandle,bufsiz,Type), % Load buffer with type
    		PXTblClose(TableHandle),!,      % Clean up the mess
		Ov_Type(FieldType,Type).        % The (3rd) callback loads the OV Fieldtype Field and return 

	Get_Table_Field(_,_,_,_,_,_,_,b_false). % it Smells on west Capitol Ave
	




	/*
	------------------------------------------------------------------
 									  
 	FUNCTION   : SelectFile ( hwnd )					  
									  
 	PURPOSE: Reads the string in the edit control of the File/Open	  
 		 dialog. If it contains a wildcard, then it attempts to   
 		 fill the listboxes in the File/Open dialog. Othewise it  
 		 ends the dialog. Modifies the FILENAME item in the property
 		 list of the window.					    
 									    

 	------------------------------------------------------------------
 	*/
 	

	PREDICATES

	select_file(HWND)
	test_filename(HWND,String)
	is_wild(STRING)


	CLAUSES  
	
	select_file(Wnd) :-

	% Get the text from the dialog's edit control into 
	% filename property 
	
		str_len(Filename,64),
		GetDlgItemText(Wnd,idd_filename,Filename,64),
		set_prop(prop_filename,Filename),
		test_filename(Wnd,Filename).



	test_filename(Wnd,Filename) :-
		is_wild(Filename), !,
		
	% Select the directory and make a listing of the directories 
	
		DlgDirList(Wnd,Filename,idd_dirs,idd_path,attr_dirs),
		filenamepath(Filename,_,Name),
    
	% List the files in this directory based on the wildcard. 
		DlgDirList(Wnd,Name,idd_files,idd_path,attr_files),

	% Set the dialog's edit control to the filename part of path
     	% string.

		SetDlgItemText(Wnd,idd_filename,Name).


	test_filename(_,Filename) :-

	% The filename in the property list is not a wildcard 

		existfile(Filename), !.


	test_filename(Wnd,Filename) :-
		MB_ok_systemmodal = mb_ok + mb_systemmodal,
		mp_error(Wnd, MB_ok_systemmodal, ids_cantopen, Filename,_),
		SetActiveWindow(Wnd).
    
  
	is_wild(Filename) :-
		searchchar(Filename,'*',_), !.  % Fails if char not found
	
	is_wild(Filename) :-
		searchchar(Filename,'?',_), !.


	PREDICATES
	
	length_bool(integer,BOOL)
  
	CLAUSES

	length_bool(0,b_false) :- !.
	length_bool(_,b_true).



	PREDICATES

	concat_stripped_filename(HWND,string,string,string)
  
	
	CLAUSES
	
	concat_stripped_filename(Wnd,Dirname,"",FullPath) :- !,
		SetDlgItemText(Wnd,idd_filename,deffilesearch),
		str_len(Filename,64),
		GetDlgItemText(Wnd,idd_filename,Filename,64),
		concat(Dirname,Filename,FullPath).
  
	concat_stripped_filename(_,Dirname,Filename,FullPath) :-
		filenamepath(Filename,_,Name),
		concat(Dirname,Name,FullPath).




	/*
	-----------------------------------------------------------
	
	Get FieldName list for a PARADOX table
	
	-----------------------------------------------------------
	*/
		
	

	PREDICATES	
	    
	load_fieldName_ListBox(HWND,STRING)
	Get_List(STRING,STRINGLIST)
        get_field_name_list(Integer,Integer,Unsigned,StringList)
	add_fields(HWND,StringList)

	CLAUSES
	

	Get_List(Table,FieldNames):-
    		pXTblOpen(Table, TblHandle, 0, 0),
		PxRecNFlds(TblHandle,NumFlds),
		get_field_name_list(0,NumFlds,TblHandle,FieldNames),
    		PXTblClose(TblHandle),!.


        get_field_name_list(X,X,_,[]):-!.
	get_field_name_list(X,NumRecs,TblHandle,[Name|FieldNames]):-
		str_len(Name,bufSiz),
    		Handle = X+1,
    		pXFldName(TblHandle,Handle,bufSiz, Name),
    		get_field_name_list(Handle,NumRecs,TblHandle,Fieldnames).
    		
	load_fieldname_ListBox(Wnd,FileName):-
		Get_List(FileName,Fields),
		SendDlgItemMessage(Wnd,idd_fields,wm_setredraw,b_false,0),
		add_fields(Wnd,Fields),!.
		
		
		
	add_fields(_,[]):-!.
	add_fields(Wnd,[_]):-
		SendDlgItemMessage(Wnd,idd_fields,wm_setredraw,b_true,0),
		fail.
	add_fields(Wnd,[Field|Fields]):-
		Item = cast(long,Field),
		SendDlgItemMessage(Wnd,idd_fields,lb_addstring,0,Item),
		add_fields(Wnd,Fields).

	
	

  
	/*
	----------------------------------------------------------------
									
	FUNCTION   : FileOpenDlgProc()					
									
	PURPOSE: Dialog function for the Fieldlist dialog. 
		 
	----------------------------------------------------------------
	*/
											  

	PREDICATES

	determ BOOL FileOpenDlgProc1(HWND, WORD, WORD, LONG)

	CLAUSES

	FileOpenDlgProc(Wnd,Msg,WParam,LParam,Ret) :- 
		GStack = MarkGStack(),
		Ret=FileOpenDlgProc1(Wnd,Msg,WParam,LParam), 
		!,
		ReleaseGStack(GStack).
    
    	
    	
	FileOpenDlgProc(Wnd,Msg,WParam,LParam,b_true):-
		BWCCDefDlgProc(Wnd,Msg,WParam,LParam).

	

	FileOpenDlgProc1(Wnd,wm_initdialog,_,_,b_true) :- !,
	% Set the default file extension on edit window, and try to
     	% get a listing of the files and directories.
     		SetDlgItemText(Wnd,idd_filename,deffilesearch),
	% disable the OK button if the edit control has text. 
		OkWnd = GetDlgItem(Wnd,idok),
		EnableWindow(OkWnd,0),
		SendDlgItemMessage(Wnd,idd_filename,em_limittext,64,0),
		select_file(Wnd).
  
	FileOpenDlgProc1(Wnd,wm_command,idok,_,b_true) :- !,
		select_file(Wnd),
		EndDialog(Wnd,0).
  
  
	FileOpenDlgProc1(Wnd,wm_command,idcancel,_,b_true) :- !,
	% Set the filename in the prop. list to NULL and quit 

		set_prop(prop_filename,""),
		EndDialog(Wnd, 0).
  
	FileOpenDlgProc1(Wnd,wm_command,idd_filename,LParam,b_true) :- !,

	% Enable the OK button if the edit control has text. 
		OkWnd = GetDlgItem(Wnd,idok),
		EditWnd = cast(HWND,LOWORD(LParam)),
		Len = GetWindowTextLength(EditWnd),
		length_bool(Len,Enable),
		EnableWindow(OkWnd,Enable).
  
	FileOpenDlgProc1(Wnd,wm_command,idd_files,LParam,b_true) :-
		Action = HIWORD(LParam),
		Action = lbn_selchange, !,

	% The files listbox. File selection has changed, fill
	% the new filename into the property list buffer and set
	% text in edit control.
     
		str_len(Filename,80),
		DlgDirSelect(Wnd,Filename,idd_files),
		SetDlgItemText(Wnd,idd_filename,Filename),
		set_prop(prop_filename,Filename),
		SendDlgItemMessage(Wnd,idd_fields,lb_ResetContent,0,0),
		load_fieldname_ListBox(Wnd,FileName),!.
    
  
	FileOpenDlgProc1(Wnd,wm_command,idd_fields,LParam,b_true) :-
		Action = HIWORD(LParam),
		Action = lbn_selchange, !,

	% The fieldname listbox. File selection has changed, fill
	% the new fieldname into the property list buffer and set
	% text in edit control.
     
		str_len(Fieldname,80),
		DlgDirSelect(Wnd,Fieldname,idd_fields),

	% get rid of thr dot		
		str_len(FieldName,Len),
		L1 = Len-1,
		frontstr(L1,Fieldname,Field,_),
		SetDlgItemText(Wnd,idd_fieldname,Field),
		set_prop(prop_fieldname,Field).
    

  
	FileOpenDlgProc1(Wnd,wm_command,idd_dirs,LParam,b_true) :-
		Action = HIWORD(LParam),
		Action = lbn_selchange, !,

	% The directories listbox. Append current filename in edit
	% control (stripped of the path prefix) to the name from
	% the property list and set the new string in the edit
	% control.
     
		str_len(Dirname,80),
		DlgDirSelect(Wnd,Dirname,idd_dirs),

	% Fetch current contents of dialog's edit control and append
	% it to name from property list... 
	
		str_len(Filename,35),
		GetDlgItemText(Wnd,idd_filename,Filename,35),
		concat_stripped_filename(Wnd,Dirname,Filename,FullPath),
	
	% Set the edit control with new string 
	
		SetDlgItemText(Wnd,idd_filename,FullPath),
		set_prop(prop_filename,FullPath).
    
	FileOpenDlgProc1(Wnd,wm_command,idd_dirs,LParam,b_true) :-
		Action = HIWORD(LParam),
		Action = lbn_dblclk, !,
		select_file(Wnd).


	FileOpenDlgProc1(_,_,_,_,b_false).  % if all else fails


